#ifndef JSON_HPP
#define JSON_HPP

#include <ArduinoJson.h>
#include <map>
#include <string>

typedef struct {
  unsigned long timestamp;
  double integ;
  double derivative;
  double esc_output;
  double speed;
  double current_speed;
  double err;
  double output;
  double kp;
  double ki;
  double kd;
  int max_speed;
  int min_speed;
  double max_esc_out;
  double min_esc_out
}PIDStruct;

typedef struct 
{
  const char * name;
  unsigned long ticks;
  unsigned long period_ticks;
  const char * unit;  
  double value;
  float unit_factor;
  unsigned long act_update_ms;
  unsigned long timestamp;
} DataStruct;

const uint8_t NR_JSON_SECTION_OBJECTS = 8;

class Myjson{

private:
public:
    String create_json_string(volatile DataStruct *data_struct, size_t nr_dataobjects, PIDStruct *pid_struct, time_t runtime_s);
};

#endif //JSON_HPP